'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DateTimeInput = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _containers = require('../containers');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('../utils.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DateTimeInput = function (_React$Component) {
  _inherits(DateTimeInput, _React$Component);

  function DateTimeInput(props) {
    _classCallCheck(this, DateTimeInput);

    var _this = _possibleConstructorReturn(this, (DateTimeInput.__proto__ || Object.getPrototypeOf(DateTimeInput)).call(this, props));

    _this.getDateTime = function (_ref) {
      var _ref$date = _ref.date,
          date = _ref$date === undefined ? '' : _ref$date,
          _ref$time = _ref.time,
          time = _ref$time === undefined ? '' : _ref$time;

      return date + ' ' + time;
    };

    _this.onDateChange = function (event, data) {
      _this.setState(function (prevState) {
        var newData = (0, _utils.cloneReplaceValue)(data, _this.getDateTime({ date: data.value.format('DD-MM-YYYY') }));
        _this.props.onChange(event, newData);
        return {
          selectedDate: data.value.format('DD-MM-YYYY')
        };
      });
    };

    _this.onTimeChange = function (event, data) {
      _this.setState(function (prevState) {
        var newData = (0, _utils.cloneReplaceValue)(data, _this.getDateTime({ date: prevState.selectedDate, time: data.value }));
        _this.props.onChange(event, newData);
        return {
          selectedTime: data.value
        };
      });
    };

    _this.state = {
      selectedDate: '',
      selectedTime: ''
    };
    return _this;
  }

  _createClass(DateTimeInput, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          placeholder = _props.placeholder,
          onChange = _props.onChange;

      var rest = (0, _utils.getUnhandledProps)(DateTimeInput, this.props);

      var inputElement = _react2.default.createElement(_semanticUiReact.Input, _extends({}, rest, {
        onChange: onChange,
        placeholder: placeholder,
        value: value,
        icon: 'calendar',
        iconPosition: 'left',
        type: 'text' }));
      return _react2.default.createElement(
        _containers.CustomPopup,
        {
          on: 'click',
          className: 'suir-calendar popup',
          hoverable: true,
          trigger: inputElement },
        _react2.default.createElement(_containers.DateTimePicker, {
          onDateChange: this.onDateChange,
          onTimeChange: this.onTimeChange })
      );
    }
  }]);

  return DateTimeInput;
}(_react2.default.Component);

DateTimeInput.handledProps = ['onChange', 'placeholder', 'value'];


DateTimeInput.propTypes = {
  /** (value) => {} where value has format 'DD-MM-YYYY hh:mm' */
  onChange: _propTypes2.default.func,
  /** selected date and time value in format 'DD-MM-YYYY hh:mm' */
  value: _propTypes2.default.string,
  placeholder: _propTypes2.default.string
};

DateTimeInput.defaultProps = {
  value: '',
  placeholder: ''
};

exports.default = DateTimeInput;
exports.DateTimeInput = DateTimeInput;